#!/usr/bin/perl -w
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

=pod "

=head1 NAME

B<mkscep-conf.pl> - Generates a SCEP configuration file

=head1 SYNOPSIS

B<mkscep-conf.pl>

=head1 DESCRIPTION

Generates a idxpki-scep configuration file and writes it on the standard
output.

=cut "

use strict;

use FindBin;

# Include installation tools.
use vars qw ($topdir);
$topdir = "$FindBin::RealBin/../../";
push (@INC, "$topdir/tools");
require InstallLib;
import  InstallLib ();
use vars qw (%CONFIG);
%CONFIG  = parseConfigStatus ($topdir);
my $vardir  = $CONFIG{'CONFIG_VARDIR'};
my $logsdir = $CONFIG{'CONFIG_LOGSDIR'};
my $scepdir = $CONFIG{'CONFIG_SCEPDIR'};
my $crldir  = $CONFIG{'CONFIG_CRLDIR'};

my $config = << "CONFIGFILE";
[ scepd ]
name = IDXPKI-SCEP
cacert = $vardir/secure/CA/OpCA.crt
cakey = $vardir/secure/CA/OpCA.key
logfile = $logsdir/sceplog
transidcheck = yes
scepdir = $scepdir
crl =  $crldir/IDX_PKI_Operational_CA.pem
#debug = 0
#crlpublic = true

CONFIGFILE

print $config;
