#!/usr/bin/perl -T

package POSIX;

=pod "

=head1 NAME

POSIX.pm - just like the POSIX.pm from the Perl main distribution,
except it is taint-safe.

=head1 SYNOPSIS

See L<POSIX>.

=head1 DESCRIPTION

=cut "

use Cwd ();

# $depth avoids too much recursion.
use vars qw ($depth);
$depth ++;
if ($depth == 1) {
	foreach my $dir (@INC) {
		if (-f "$dir/POSIX.pm") {
			require "$dir/POSIX.pm";
			next;
		}
	}

	{
		no warnings "all";

		*POSIX::getcwd = sub{
			# Cwd::abs_path does only readdir()s, it should be safe.
			Cwd::abs_path(".") =~ m/^(.*)$/;
			return $1;
		};
	}

	eval join("",<main::DATA>) || die $@ unless caller();
}

1;

__END__

############### TEST SUITE ##############################

use Taint;
use Test;

plan tests => 1;

ok(!Taint::tainted(POSIX::getcwd()));

1;
