#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

# $Id: ca-crl-issue.cgi,v 1.21 2003/07/23 13:20:48 mbrossard Exp $
# $Source: /opt/cvs/idxpki/sources/src/perlscript/CA/ca-crl-issue.cgi,v $

=pod "

=head1 NAME

ca-crl-issue.cgi - Issues a new CRL and shows its details

=cut "

use strict;

use IDX::PKI::Registry;
use IDX::PKI::CA;
use IDX::PKI::Authentication qw(authorize);

############### CGI init ####################
$cgi->setupViews("ca-crl-details.php");

############### Configuration informations ####################
$cgi->authorize ("PRIV_USE", "ACL-".$config->getval('CA', 'web_acl'));

my $crl;
$log->attempt("CRL_ISSUE", sub {
				  my $ca = new IDX::PKI::CA ($log);
				  $crl = $ca->issueCrl();
				  return { -attachment => [ $crl ] };
			  });

my %crl_arr;
my @attrs = ("dn_issuer",
			 "last_update",
			 "next_update",
			 "certificates");

foreach my $attr (@attrs) {
	$crl_arr{$attr} = $crl->getAttribute ($attr);
}		
$cgi->success(\%crl_arr);
