#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

use strict;

use IDX::PKI::Config;
use IDX::PKI::Registry;
use IDX::PKI::Error;
use IDX::PKI::CA;
use IDX::PKI::Transport;
use IDX::PKI::Principal qw (pullCRR);

use MIME::Base64;

=pod "

=head1 NAME

B<ca-crr-accept.cgi> - Script to accept a Certificate Revocation Request

=cut "

############### CGI, Config and Log init ####################
$cgi->setupViews ("ca-crr-accept.php");

############### Configuration informations ####################
$cgi->authorize ("PRIV_USE",
				 $config->getSectionName ("CA", ["ACL", "web_acl"]));
$log->addAuthorizer ($cgi->getPeerCertificate ());

my $section   = $config->getval ("CA", "crr_transport_in");
my $transport = new IDX::PKI::Transport::Unspooler
	("TRANSPORT-IN-".$section);

my $id = $cgi->validate ("id" => \&IDX::PKI::ValidateInput::messageID);
$cgi->error (INPUT_HIDDEN) if ($cgi->validateFailures());

################ Read pending CRR ###############################
$log->attempt
	("CRR_ACCEPT",
	 sub {
		 my $crr = pullCRR ($transport, $id) || $cgi->failure (TRANSPORT_MSG);
		 my $ca = new IDX::PKI::CA ($log);
		 $ca->crr_accept ($crr);
		 $transport->expunge();
		 return {"-attachment" => $crr};
	 });

$cgi->success (0);
