#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

use strict;

use IDX::PKI::Config;
use IDX::PKI::Error;
use IDX::PKI::Registry;
use IDX::PKI::Crypto::CRR;
use IDX::PKI::Transport;
use IDX::PKI::Principal qw (pullCRR);

=pod "

=head1 NAME

B<ca-crr-reject.cgi> - Script to reject a Certificate Revocation Request

=cut "

############### CGI, Config and Log init ####################
$cgi->setupViews ("ca-crr-reject.php");

############### Configuration informations ####################
$cgi->authorize ("PRIV_USE",
				 $config->getSectionName ("CA", ["ACL", "web_acl"]));
$log->addAuthorizer ($cgi->getPeerCertificate ());

my $section = $config->getval ("CA", "crr_transport_in");
my $transport = new IDX::PKI::Transport::Unspooler
	("TRANSPORT-IN-".$section);

################ Call Parameters #############################
my $id = $cgi->validate ("id", \&IDX::PKI::ValidateInput::messageID);
$cgi->error (INPUT_HIDDEN) if ($cgi->validateFailures() &&
							   $cgi->internalparam ("ERROR_id"));

$log->attempt
	("CRR_REJECT",
	 sub {
		 my $crr = pullCRR ($transport, $id) || $cgi->failure (TRANSPORT_MSG);
		 # Nothing to do except expunge ().
		 $transport->expunge();
		 return {"-attachment" => $crr};
	 });

$cgi->success (0);
