#!/usr/bin/perl -w

# Restarts Apache ("hard" restart - graceful has memory leaks) if CRL
# changed. This script may be setuid to whatever user starts Apache.
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

use strict;
use IDX::PKI::Config;

# Kick Apache if CRL changed for any reason. We use the CRL and
# the PID file as timestamps. If the command line of the old process 

our $config = the IDX::PKI::Config ();

our $pidfile = $config->getval ("paths", "vardir")."/run/idxpki-httpd.pid";
our $crl = $config->getval ("paths", "crldir")."/crl-bundle.pem";

my @p=stat($pidfile) or die "Apache appears to not be running\n";

my $piddate=$p[9];

@p=stat($crl) or exit 0;

my $crldate=$p[9];

exit 0 if ($piddate >= $crldate);

my $pid;
open(PIDFILE,"<$pidfile") || die "Apache appears to not be running\n";
$_=<PIDFILE> || die "$pidfile contains no PID ?!\n";
chomp;
m/^(\d+)/ || die "$pidfile contains no PID ?!\n";
$pid=$1; # untainted
close PIDFILE;

# There are memory leaks out there, and we need to handle the case of the first CRL, in which the command line of Apache has to change.
#	kill HUP => $pid;

$< = $>;            # set real to effective uid

system ($config->getval ("paths", "sysvdir")."/idxpki-httpd","stop");
system ($config->getval ("paths", "sysvdir")."/idxpki-httpd","start");

open(PIDFILE,">>$pidfile"); close PIDFILE; # Updates timestamp

