#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

# $Id: ee-cert-get.cgi,v 1.25 2003/08/06 12:20:12 mbrossard Exp $
# $Source: /opt/cvs/idxpki/sources/src/perlscript/EE/ee-cert-get.cgi,v $

=pod "

=head1 NAME

ee-cert-get.cgi - Retrieves someone else's certficate from the repository for incorporation into a browser

=cut "

use strict;

use IDX::PKI::Registry;
use IDX::PKI::Error;
use IDX::PKI::CertDB;

############### CGI init ####################
$cgi->setupViews("ee-cert-get.php");
$cgi->authorize("__NONE__");

############### Configuration informations ####################
my $serial = $cgi->validate("serial", qr/([a-f-A-F0-9]+)/)
  || $cgi->error(INPUT_HIDDEN);
my $browser = $cgi->validate("browser", qr/([a-z-A-Z]+)/)
  || $cgi->error(INPUT_HIDDEN);
my $pem = $cgi->validate ("PEM", \&IDX::PKI::ValidateInput::boolean);
my $der = $cgi->validate ("DER", \&IDX::PKI::ValidateInput::boolean);

################ Certificate search ###############################
my $x509;
try {
	my $reader = new IDX::PKI::CertDB::CA ("EE");
	$x509 = $reader->searchCerts ('serial' => $serial);
} catch IDX::PKI::Error::Network with {
	cgi->failure(REPOSITORY_CONNECT);
};
$cgi->error (REPOSITORY_NOENTRY) unless ($x509);

################ Certificate output ###############################
my ($type, $output, $name);
if (defined $browser) {
	if ($browser =~ m/NETSCAPE/i) {
		$type   = "application/x-x509-email-cert";
		$output = $x509->serialize ('PEM');
	} elsif ($browser =~ m/IE/i) {
		$type = "application/pkix-cert";
		$output = $x509->serialize ('DER');
	} else {
		$cgi->error (MISC_BROWSER);
	}
} elsif ($pem) {
	$type   = "application/octet-stream";
	$output = $x509->serialize ('PEM');
	$name = "certificate.pem";
} elsif ($der) {
	$type = "application/octet-stream";
	$output = $x509->serialize ('DER');
	$name = "certificate.der";
} else {
	$cgi->error (INPUT_HIDDEN);
}

$cgi->{printing_allowed} = 1;

$cgi->content_type($type);
$cgi->content_length (length ($output));
$cgi->attachment ("$name") if ($name);
$cgi->print ($output);
exit;
