#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

=pod "

=head1 NAME

B<ee-cert-retrieve.cgi> - Retrieves one's own certficate from the repository for incorporation into the browser

=cut "

use strict;

use IDX::PKI::Registry;
use IDX::PKI::Error;
use IDX::PKI::CertDB;

############### CGI init ####################
$cgi->setupViews("ee-cert-retrieve.php");
$cgi->authorize("__NONE__");

############### Call parameters ####################
my $serial = $cgi->validate("serial", qr/([a-f-A-F0-9]+)/)
  || $cgi->error(INPUT_HIDDEN);
my $browser = $cgi->validate("browser", qr/([a-z-A-Z]+)/)
  || $cgi->return (INPUT_HIDDEN);

################ Certificate search ###############################
my $x509;
try {
	my $reader = new IDX::PKI::CertDB::CA ("EE");
	$x509 = $reader->searchCerts(serial  => $serial);
} catch IDX::PKI::Error::Network with {
	cgi->failure (REPOSITORY_CONNECT);
};

$cgi->error (REPOSITORY_NOENTRY) unless ($x509);

################ Certificate output ###############################
if ($browser =~ m/NETSCAPE/i) {
	my $der = $x509->serialize ('DER');
	$cgi->{printing_allowed} = 1;
	$cgi->content_type("application/x-x509-user-cert");
	$cgi->content_length (length ($der));
	$cgi->print ($der);
	exit ();
} elsif ($browser =~ m/IE/i) {
	my $pkcs7 = $x509->serialize("IE");
	$cgi->success ($pkcs7);
} else {
	$cgi->error (MISC_BROWSER);
}
