#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

=pod "

=head1 NAME

B<ra-csr-form.cgi> - Create form for a certificate profile

=cut "

use strict;

use IDX::PKI::Registry;
use IDX::PKI::Error;
use IDX::PKI::Profile;
use IDX::PKI::Authentication qw(authorize);

############### CGI, Config and Log init ####################
$cgi->setupViews (-success => "ra-csr-form.php",
				  -error => "ra-csr-form.php");

############### Configuration informations ####################
$cgi->authorize ("PRIV_USE", "ACL-".$config->getval ('RA', 'web_acl'));

############### Call Parameters ####################
my $profilename = $cgi->validate ("profile", qr/^\s*([a-z0-9\-_.]+)\s*$/i)
  || $cgi->error(INPUT_HIDDEN);

my $profile = new IDX::PKI::Profile ($profilename);

my %ret = ('profile' => $profile->getName (),
		   'title'   => {$profile->getTitlesI18N()},
		   'type'    => $profile->getType (),
		   # Warning, we want them as references, not arrays.
		   'rdns'    => [$profile->getDNElements ()],
		   'form'    => [$profile->getFormElements ()],
		   'exts'    => [$profile->getExtensions ()]);

$cgi->success (\%ret);

