#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

=pod "

=head1 NAME

B<ra-csr-profile.cgi> - Lists all the profiles available for the RA

=cut "

use strict;
use IDX::PKI::Error;
use IDX::PKI::Registry;
use IDX::PKI::Profile;
use IDX::PKI::Principal;
use IDX::PKI::Authentication qw(authorize);

############### CGI init ####################
$cgi->setupViews("ra-csr-profile.php");

############### Access Restriction ####################
$cgi->authorize ("PRIV_USE", "ACL-".$config->getval ('RA', 'web_acl'));

# Build list of allowed profiles.
my @ret;
foreach my $name ("central", "server") {
	my $profile = new IDX::PKI::Profile ($name);
	push (@ret, [$profile->getName (),
				 {$profile->getTitlesI18N()}]);
}
$cgi->success(\@ret);

