#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

=pod "

=head1 NAME

B<ra-recovery-list.cgi> - List pending key recovery requests

=cut "

use strict;

use IDX::PKI::Config;
use IDX::PKI::Registry;
use IDX::PKI::Error;
use IDX::PKI::Transport;
use IDX::PKI::Message::TrustedRequest;
use IDX::PKI::Authentication qw(authorize is_authorized);

############### CGI, Config and Log init ####################
$cgi->setupViews ("ra-recovery-list.php");

############### Access Restriction ####################
$cgi->authorize ("PRIV_USE", "ACL-".$config->getval ('RA', 'web_acl'));

############### Configuration informations ####################
my $section = $config->getval ('RA', 'krr_transport_in');
my $transport = new
	IDX::PKI::Transport::Unspooler ("TRANSPORT-IN-".$section);

################ Read list of pending messages #############################
my @list_of_messages;
try {
	@list_of_messages = $transport->list ();
} otherwise {
	my ($E) = @_;
	$log->alert ("TRANSPORT_MSG",
				 "-details" => "Transport: TRANSPORT-IN-".$section,
				 "-attachment" => $E);
	$cgi->failure (TRANSPORT_MSG);
};

my @pending_rr_list = ();

foreach my $id (@list_of_messages) {
	my $request;
	try {
		$request = $transport->readByID ($id,
										 'IDX::PKI::Message::TrustedRequest');
	} otherwise {
		my ($E) = @_;
		$log->alert ("TRANSPORT_MSG",
					 "-details" => ["Transport: TRANSPORT-IN-".$section,
									"Message ID: $id"],
					 "-attachment" => $E);
	};
	next unless ($request);

		push (@pending_rr_list,
			  [$id, $request->getState (undef, "idxpkiSubjectID"),
			   $request->getState (undef, "reason")]);
}

$cgi->success (\@pending_rr_list);
