#!/usr/bin/perl
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

=pod "

=head1 NAME

B<ra-recovery-reject.cgi> - Reject a pending key recovery request

=cut "

use strict;

use IDX::PKI::Registry;
use IDX::PKI::Error;
use IDX::PKI::Principal;
use IDX::PKI::Authentication qw(authorize);
use IDX::PKI::Transport;
use IDX::PKI::Message::TrustedRequest;

############### CGI init ####################
$cgi->setupViews ("ra-recovery-reject.php");

############### Access Restriction ####################
$cgi->authorize ("PRIV_USE", "ACL-".$config->getval ('RA', 'web_acl'));

############### Configuration informations ####################
my $section = "TRANSPORT-IN-".$config->getval ('RA', 'krr_transport_in');
my $transportin = new IDX::PKI::Transport::Unspooler($section);

############### Call parameters ####################
my $id = $cgi->validate ("id" => \&IDX::PKI::ValidateInput::messageID) ||
  $cgi->error (INPUT_HIDDEN);

my $request;
try {
	# Read the message.
	$request = $transportin->pullByID
	  ($id, 'IDX::PKI::Message::TrustedRequest');
} catch IDX::PKI::Error with {
	$cgi->failure (TRANSPORT_MSG);
};
$cgi->error (TRANSPORT_MSG) unless ($request);


$log->attempt
  ({ "KRR_REJECT",
	 -details => ["certificate with serial ".
				  $request->getState (undef, 'serial')."."]},
   sub {
	   # Destroy the request.
	   $transportin->expunge ();
   });

$cgi->success(0);
