#!/usr/bin/perl -w
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

# $Id: changeprivs.cgi,v 1.32 2003/08/07 11:40:28 mbrossard Exp $
# $Source: /opt/cvs/idxpki/sources/src/perlscript/config/changeprivs.cgi,v $

use strict;

use IDX::PKI::Config;
use IDX::PKI::Error;
use IDX::PKI::Registry;
use IDX::PKI::Interface::ChangePrivs;

use IDX::PKI::Authentication qw (%privilegeNames);

=pod "

=head1 NAME

B<changeprivs.cgi> - Performs privileges configuration

=head1 EXPECTED PARAMETERS

Waits for a form like this:

=over 4

=item C<MODIFY_DN_0="CN=whomever, O=here, C=net">

=item C<SET_PRIV_CONFIG_0="y">

=item C<SET_PRIV_MAINT_0="y">

=item C<SET_PRIV_CHPRIV_0="y">

=item C<MODIFY_DN_1="CN=someoneelse, O=here, C=net">

=item C<MODIFY_DN_2="CN=anotherguy, O=here, C=net">

=item C<SET_PRIV_USE_2="y">

=back

and for a C<section> parameter within C<ACL-CA>, C<ACL-RA> and C<ACL-EE>.

Returns a negative value on error.

=cut "

$cgi->setupViews ("-success" => "listprivs.cgi?section=%s",
				  "-error"   => "privs.php");

# Authentication section depends on an input parameter...
$cgi->authorize ("__NONE__");
my $section = $cgi->validate ("section", qr /^(ACL-[a-zA-Z]+)$/);
$cgi->error (INPUT_HIDDEN) if ($cgi->validateFailures () &&
							   $cgi->internalparam ("ERROR_section"));
$cgi->error (INPUT_HIDDEN) if (! $config->SectionExists ($section));

$cgi->authorize ("PRIV_CHPRIV", $section);


# Now parses the input and tries to save the changes.
IDX::PKI::Interface::ChangePrivs::runChange
	($cgi, $config, $log, $section, keys %privilegeNames);

$cgi->success ($section);
