#!/usr/bin/perl -w
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

# $Id: config-ee.cgi,v 1.18 2003/01/13 12:32:57 laura Exp $
# $Source: /opt/cvs/idxpki/sources/src/perlscript/config/config-ee.cgi,v $

=pod "

=head1 NAME

B<config-ee.cgi> - Configuration of the Enrolment Entity

=cut "

use strict;

use IDX::PKI::Config;
use IDX::PKI::Error;
use IDX::PKI::Registry;

$cgi->setupViews ("config-ee.php");

$cgi->authorize ("PRIV_CONFIG",
				 $config->getSectionName ("EE", ["ACL" => "web_acl"]));

$log->addAuthorizer ($cgi->getPeerCertificate ());

############### Configuration informations ####################

# Read values from disk the first time
my $admin_email = $config->getPath ('EE', 'admin_email') || "";

# Check whether the validation button has been clicked.
my $valid = $cgi->validate ("valid", \&IDX::PKI::ValidateInput::boolean,
							"-default" => undef);
$cgi->error (INPUT_HIDDEN) if ($cgi->validateFailures());

if ($valid) {
	$admin_email = $cgi->validate ("admin_email",
								   \&IDX::PKI::ValidateInput::email);
	if ($cgi->validateFailures ()) {
		$cgi->internalparam ("ERROR", 'adminEmail');
		($cgi->internalparam ("ERROR_admin_email") eq "MISSING") ?
			$cgi->error (INPUT_MISSING) :
			$cgi->error (INPUT_FORMAT);
	}

	# Write the configuration on disk.
	try {
		$log->attempt
			(["CONFIG", -details => "Entity: EE"],
			 sub {
				 IDX::PKI::Config->updateLocked (sub {
					 my ($config) = @_;
					 $config->setval ('EE', 'admin_email', $admin_email);
				 });
				 return {-details => ["admin_email: \"$admin_email\""]};
			 });
	} catch IDX::PKI::Error with {
		$cgi->failure (CONFIG_SAVING);
	};
} else {
	$cgi->param ("admin_email", $admin_email);
}

$cgi->success ($valid ? 1 : 0);
