#!/usr/bin/perl -w
#
# This code was developped by IDEALX (http://IDEALX.org/).
# 
# Copyright  2000-2003 IDEALX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.

# $Id: config-ra.cgi,v 1.18 2003/01/13 12:32:57 laura Exp $
# $Source: /opt/cvs/idxpki/sources/src/perlscript/config/config-ra.cgi,v $

=pod "

=head1 NAME

B<config-ra.cgi> - Configuration of the Registration Authority

=cut "

use strict;

use IDX::PKI::Config;
use IDX::PKI::Error;
use IDX::PKI::Registry;

use constant DEFAULT_MODE => 'manual';

$cgi->setupViews ("config-ra.php");

$cgi->authorize ("PRIV_CONFIG",
				 $config->getSectionName ("RA", ["ACL" => "web_acl"]));

$log->addAuthorizer ($cgi->getPeerCertificate ());

# Get the mode from the configuration file
my $mode = $config->getPath('RA', 'mode') || DEFAULT_MODE;

# Check whether the validation button has been clicked.
my $valid = $cgi->validate ("valid", \&IDX::PKI::ValidateInput::boolean,
							"-default" => undef);
$cgi->error (INPUT_HIDDEN) if ($cgi->validateFailures());

if ($valid) {
	$mode = $cgi->validate ("mode", \&IDX::PKI::ValidateInput::choice,
							"-extraargs" => ["manual", "auto"]);
	$cgi->error (INPUT_HIDDEN) if ($cgi->validateFailures ());

	try {
		$log->attempt
			(["CONFIG", -details => "Entity: RA"],
			 sub {
				 IDX::PKI::Config->updateLocked (sub {
					 my ($config) = @_;
					 $config->setval ('RA', 'mode', $mode);
				 });
				 return {-details => ["mode: \"$mode\""]};
			 });
	} catch IDX::PKI::Error with {
		$cgi->failure (CONFIG_SAVING);
	};
} else {
	$cgi->param ("mode", $mode);
}

$cgi->success ($valid ? 1 : 0);
