<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

$relativepath = "..";
include_once "$relativepath/pki-shared.inc";

print_html_header("ca", "ca-csr-details", $relativepath);

/* Get the return value of the cgi. */
$data = getData();
$myid = $HTTP_GET_VARS["id"];

if (! isset ($data)) {
	error ("ThisScriptShouldNotBeCalledDirectly");
} elseif ((int) $data < 0) {
	$field = strip_tags ($HTTP_GET_VARS["ERROR"]);
	error ((int) $data, ($field ? msg ("Form", $field, 'i') : ''));
} else {
	$dn = $data[0];
	$form = $data[1];

	print begin_table();
	if (count ($dn)) {
		print table_title_line(msg("Message", "DistinguishedName", "h2"));
		/* DN */
		while (count ($dn)) {
			$k = array_shift ($dn);
			$v = array_shift ($dn);
			if ($v) print table_element_line(msg("Form", $k, "i").":",$v);
		}
	}

	print table_title_line(msg("Message", "Extensions", "h2"));
	/* Certificate extensions. */
	foreach ($List_of_Extensions as $extension_family => $extension_list) {
		$ext_lst = "";
		foreach ($extension_list as $extension_key) {
			if ($form[$extension_key]) {
				$ext_lst .= ($ext_lst ? ", " : "") .
					 msg ($extension_family, $extension_key, "i");
				unset ($form[$extension_key]);
			}
		}
		if ($ext_lst) {
			print table_element_line(msg("Extension", $extension_family, "i"), $ext_lst);
		}
	}

	print table_title_line(msg("Message", "Data", "h2"));
	/* Build Form */
	foreach ($form as $k => $v) {
		if ($v) {
			if (is_array ($v)) {
				foreach ($v as $realv) {
					if ($realv) {
						print table_element_line(msg ("Form", $k, "i"),
												 $realv);
					}
				}
			} else {
				if ($v) print table_element_line(msg ("Form", $k, "i"), $v);
			}
		}
	}
	print end_table();
	
	print begin_table().
		table_title_line(quick_form ("ca-csr-accept.cgi", "id", $myid,
									 msg ("Value","Accept", "n"))).
		end_table();
	
	print begin_table().
		table_title_line(quick_form ("ca-csr-reject.cgi", "id", $myid,
									 msg ("Value","Reject", "n"))).
		end_table();
}

print_html_footer();

?>