<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

$relativepath = "..";
include_once "$relativepath/pki-shared.inc";

$serversearch = $HTTP_GET_VARS["server"];
$revoking = $HTTP_GET_VARS["revoking"];
$recovery = $HTTP_GET_VARS["recovery"];
if ($serversearch) {
	$titleref = "ee-server";
} elseif ($revoking) {
	$titleref = "ee-revoke";
} elseif ($recovery) {
	$titleref = "ee-recover";
} else {
	$titleref = "ee-search";
}

print_html_header("ee", $titleref, $relativepath);

/* Get the return value of the cgi. */
$data = $HTTP_SERVER_VARS["REDIRECT_DATA"];

$BROWSER = (ereg("IE", $HTTP_SERVER_VARS["HTTP_USER_AGENT"])) ? "IE" :
	"NETSCAPE";

if (isset ($data)) {
	if (get_magic_quotes_gpc ()) {
		$data = stripslashes ($data);
	}
	eval ("\$data = $data;");
}

/* If we weren't called by CGI or if some modifications are required from
   user, display the form. */

if (!isset ($data) || ((int)$data < 0)) {
	/* Out some error messages. */
	if ((int)$data < 0) {
		$field = strip_tags ($HTTP_GET_VARS["ERROR"]);
		error ((int) $data, ($field ? msg ("Form", $field, 'i') : ''));
	}

	/* The list of parameters we expect. */
	if ($serversearch) {	/* Server certificates search. */
		$params = array (
			"idxpkiSubjectIDServerMode", # Special case...
			"idxpkiSerial",
			);
	} else {				/* User certificates search. */
	  $params = array ("idxpkiSubjectID",
					   "idxpkiSubjectEmail",
					   "idxpkiSerial");
	}

	print '<form action="ee-certs-search.cgi" method="post">
<table width="100%" border="0" cellspacing="0" cellpadding="5" bgcolor="#E5ECEE">
';
	foreach ($params as $k) {
		$v = msg("Form", $k, "i");
		if ($k == "idxpkiSubjectIDServerMode") {
			$name_k = "idxpkiSubjectID"; # Special case... (followed)
		} else {
			$name_k = $k;
		}
		print '<tr><td>
<font face="Arial Narrow, Geneva, Arial" size="2" color="#00415A">'.$v.':</font>
</td><td>
<input type="text" name="'.$name_k.'" value="'.$HTTP_GET_VARS[$name_k].'">
</td></tr>
';
	}
	print "</table>\n";
	if ($serversearch) print "<input type='hidden' name='server' value='1'>\n";
	if ($revoking) print "<input type='hidden' name='revoking' value='1'>\n";
	if ($recovery) print "<input type='hidden' name='recovery' value='1'>\n";
	print "<input type='submit' value='".msg("Value","Search", "n")."'>\n</form>\n";
} else {
	/* Display the result of our query. */
	if (count($data) == 0) {
		print yellow_msg ("Message", "NoMatchingCertificate", "info");
	} else {
		print "<p>".msg ("Message", "NumberOfMatchingCertificates", "n").
			count($data).".</p>\n";

		print begin_table ();

		foreach ($data as $i => $cert) {
			$num = $i + 1;
			print table_title_line (msg ("Message", "Certificate", "i").$num);

			foreach ($cert as $k => $v) {
				$label = msg("Form", $k, "i");
				/* Translate the value? */
				if ($k == "idxpkiStatus") $v = msg ("Form", $v, "i");
				if (isset ($label) && isset ($v) && ($v != "")) {
					print table_element_line ($label, $v);
				}
			}

			print "<tr><td colspan='2' align='center'>\n";
			if ($serversearch) {
				print
					quick_form2	('ee-cert-get.cgi',
								 array('serial' => $cert["idxpkiSerial"],
									   'DER' => 1),
								 msg ("Value", "FormatPEM", "n"))."\n".
					quick_form2	('ee-cert-get.cgi',
								 array('serial' => $cert["idxpkiSerial"],
									   'PEM' => 1),
								 msg ("Value", "FormatPEM", "n"));
			} elseif ($revoking) {
				print "<form method='post' action='ee-revoke.cgi'>\n";
				print "<input type='hidden' name='idxpkiSerial' ".
					"value='".$cert["idxpkiSerial"]."'/>\n";
				foreach ($cert as $k => $v) {
					print "<input type='hidden' name='$k' value='$v'/>\n";
				}
				print "<input type='submit' value='".
					msg ("Value", "RevokeThisCertificate", "n").
					"'/>\n";
				print "</form>\n";
			} elseif ($recovery) {
				print "<form method='GET' action='ee-recover.cgi'>\n";
				print "<input type='hidden' name='idxpkiSerial' ".
					"value='".$cert["idxpkiSerial"]."'/>\n";
				foreach ($cert as $k => $v) {
					print "<input type='hidden' name='$k' value='$v'/>\n";
				}
				print "<input type='submit' value='".
					msg ("Value", "RecoverThisCertificate", "n").
					"'/>\n";
				print "</form>\n";
			} else {
				print
					quick_form2	('ee-cert-retrieve.cgi',
								 array('serial' => $cert["idxpkiSerial"],
									   'browser' => $BROWSER),
								 msg ("Value", "RetrieveTheCertificate", "n"))."\n".
					quick_form2	('ee-cert-get.cgi',
								 array('serial' => $cert["idxpkiSerial"],
									   'browser' => $BROWSER),
								 msg ("Value", "CopyTheCertificate", "n"));
			}
			print "</td></tr>\n";
		}
		print end_table ();
	}
}

print_html_footer();

?>
