<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

$relativepath = "..";
include_once "$relativepath/pki-shared.inc";

print_html_header("ee", "ee-crr-create", $relativepath);

/* Get the return value of the cgi. */
$data = getData();

if (isset ($data) && ((int)$data == 0)) {
	print yellow_msg ("Message", "YourRevocationRequestHasBeenSent",
					  "success");
} elseif (!$HTTP_SERVER_VARS["SSL_CLIENT_CERT"]) {
	print yellow_msg ("EE", "YouMustConnectSecure", "error");
} else {
	if ((int)$data < 0) {
		$field = strip_tags ($HTTP_GET_VARS["ERROR"]);
		error ((int) $data, ($field ? msg ("Form", $field, 'i') : ''));
	}

	/* get user certificate from environment to revoke it */
	/* What infos we want except DN elements. */
	$informations = array (
		"certificationAuthority" => $HTTP_SERVER_VARS["SSL_CLIENT_I_DN"],
		"certificate"            => $HTTP_SERVER_VARS["SSL_CLIENT_CERT"],
		"serial"                 => $HTTP_SERVER_VARS["SSL_CLIENT_M_SERIAL"],
		"notBefore"              => $HTTP_SERVER_VARS["SSL_CLIENT_V_START"],
		"notAfter"               => $HTTP_SERVER_VARS["SSL_CLIENT_V_END"],
	);

	/* some warning */
	print yellow_msg ("EE", "YouAreAboutToRevoke", "error");
	print "<p>".msg ("EE", "CertificateToBeRevoked", "i")."</p>\n";

	print begin_table ();

	foreach ($ldap_names as $k => $v) {
		$content = $HTTP_SERVER_VARS["SSL_CLIENT_S_DN_".$v];
		$label = msg ("Form", $k, "i");
		if ($content) print table_element_line ($label, $content);
	}

	foreach ($informations as $k => $v)	{
		if ($v) {
			$label = msg ("Form", $k, "i");
			print table_element_line ($label, ($k == "certificate") ?
									  "<pre class='certif'>$v</pre>" : $v);
		}
	}
	print end_table ();

	print "<form action='ee-crr-create.cgi' method='POST'>\n";

	/* Reason of revocation. */
	print "<p>".msg ("Form", "reason", "i")."\n";
	print "<select name='reason'>\n";
	$paramreason = $HTTP_GET_VARS["reason"];
	if (! $paramreason) $paramreason = "unspecified";
	$list = array ("unspecified", "keyCompromise", "cACompromise",
				   "affiliationChanged", "cessationOfOperation",
				   "superseded", "certificateHold", "removeFromCRL");
	foreach ($list as $reason) {
		print "<option value='$reason'".
			($reason == $paramreason ? " selected" : "").">".
			msg ("Form", $reason, "i")."</option>\n";
	}
	print "</select></p>\n";

	/* Free comment. */
	print "<p>".msg ("Form", "comment", "i")."</p>\n";
	print "<p><textarea name='comment' rows='4' cols='40'>".
		$HTTP_GET_VARS["comment"]."</textarea></p>\n";

    print "<input type='submit' name='submit' value='".
		msg ("Value", "Revoke", "n")."'/>\n";
	print "</form>\n";
	print quick_form ('../index.php', "dummy", "1",
					  msg ("Value", "Cancel", "n"));
}

print_html_footer();

?>
