<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

$relativepath = "..";
include_once "$relativepath/pki-shared.inc";

print_html_header("ee", "ee-revoke", $relativepath);

/* Get the return value of the cgi. */
$data = getData();


if (isset ($data) && ((int)$data == 0)) {
	print yellow_msg ("Message", "YourRevocationRequestHasBeenSent",
					  "success");
} else {
	if ((int)$data < 0) {
		$field = strip_tags ($HTTP_GET_VARS["ERROR"]);
		error ((int) $data, ($field ? msg ("Form", $field, 'i') : ''));
	}

	/* some warning */
	print yellow_msg ("EE", "WarningRevokeOtherCert", "error");
	print "<p>".msg ("EE", "CertificateToBeRevoked", "i")."</p>\n";

	print begin_table ();
	/* What infos we want except DN elements. */
	$informations = array ("idxpkiSubject",
						   "idxpkiSubjectID",
						   "idxpkiSubjectEmail",
						   "idxpkiSerial",
						   "idxpkiCertPublicationTime",
						   "idxpkiCertExpirationTime");
	foreach ($informations as $k) {
		if ($HTTP_GET_VARS[$k]) {
			$v = $HTTP_GET_VARS[$k];
			$label = msg ("Form", $k, "i");
			/* Translate the value? */
			if ($k == "idxpkiStatus") $v = msg ("Form", $v, "i");
			if (isset ($label) && isset ($v) && ($v != "")) {
				print table_element_line ($label, $v);
			}
		}
	}
	print end_table ();

	print "<form action='ee-revoke.cgi' method='POST'>\n";
	print "<input type='hidden' name='idxpkiSerial' value='".
		$HTTP_GET_VARS["idxpkiSerial"]."'/>\n";

	/* Author of the request. */
	print "<p>".msg ("Form", "requester", "i")."\n";
	$requester = $HTTP_GET_VARS["requester"];
	if (! $requester) {
		$requester = $HTTP_SERVER_VARS["SSL_CLIENT_S_DN_CN"];
	}
	print "<input type='text' name='requester' value='$requester'/></p>\n";

	/* Reason of revocation. */
	print "<p>".msg ("Form", "reason", "i")."\n";
	print "<select name='reason'>\n";
	$paramreason = $HTTP_GET_VARS["reason"];
	if (! $paramreason) $paramreason = "unspecified";
	$list = array ("unspecified", "keyCompromise", "cACompromise",
				   "affiliationChanged", "cessationOfOperation",
				   "superseded", "certificateHold", "removeFromCRL");
	foreach ($list as $reason) {
		print "<option value='$reason'".
			($reason == $paramreason ? " selected" : "").">".
			msg ("Form", $reason, "i")."</option>\n";
	}
	print "</select></p>\n";

	/* Free comment. */
	print "<p>".msg ("Form", "comment", "i")."</p>\n";
	print "<p><textarea name='comment' rows='4' cols='40'>".
		$HTTP_GET_VARS["comment"]."</textarea></p>\n";

    print "<input type='submit' name='submit' value='".
		msg ("Value", "Revoke", "n")."'/>\n";
	print "</form>\n";
	print quick_form ('../index.php', "dummy", "1",
					  msg ("Value", "Cancel", "n"));

}

print_html_footer();

?>
