<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

/* $Id: ra-csr-form.php,v 1.28 2004/02/04 16:41:01 mbrossard Exp $ */
/* $Source: /opt/cvs/idxpki/sources/src/php/RA/ra-csr-form.php,v $ */

$relativepath = "..";
include_once "$relativepath/pki-shared.inc";

print_html_header("ra", "ra-csr-form", $relativepath);

/* Get the return value of the cgi. */
$data = getData();

if (!isset ($data)) {
	error ("ThisScriptShouldNotBeCalledDirectly");
} elseif ((int) $data < 0) {
	$field = strip_tags ($HTTP_GET_VARS["ERROR"]);
	error ((int) $data, ($field ? msg ("Form", $field, "i") : ""));
} else {
	print "<form method='POST' name='REQUEST' action='ra-csr-send.cgi'>\n";
	print "<table>\n";

	/* DN and form elements. */

	foreach (array ("rdns", "form") as $elemtype) {
		foreach ($data[$elemtype] as $elem) {
			$name = $elem["long"];
			$count = ++ $counter[$name];

			/* Check if the field has to be asked twice. */
			$verif = ($elem["options"]["verify"]) ? array ("a", "b") :
				array ("");
			foreach ($verif as $append) {
				/* Value to propose. */
				$user_default =	$HTTP_GET_VARS
				   ["TRUSTED_$name$count$append"];
				if ($user_default != "") {
					$default = $user_default;
				} else {
					$default = $elem["default"];
				}

				$mandatory = ($elem["req"] == "mandatory") ? $star : "";
				$text1 = $mandatory.msg ("Form", $name, "i").
					($append == "b" ? " ".msg ("Form", "dup", "i") :
					 "").": ";

				/* Fixed fields are handled in CGIs. */
				if($elem["req"] == "fixed") {
				  $text2 = $elem["default"];
				} else {
					if ($elem["type"] == "choice") {
						$options = "";
						foreach ($elem["choices"] as $opt) {
							$selected = ($opt == $default ?
								" selected" : "");
							$options .= "<option value='$opt'$selected>".
								"$opt</option>\n";
						}
						$text2 = "<select name='$name$count$append'>\n".
							"$options</select>\n";
					} elseif ($elem["type"] == "pem") {
						$text2 = "</td></tr><tr><td colspan='2'>\n".
							"<textarea name='$name$count$append' cols='65'".
							"rows='20'>$default</textarea>\n";
					} else {
						$type = $elem["options"]["password"] ? "password" :
							"text";
						$size = ($elem["maxlength"] <= 16) ?
							$elem["maxlength"] :
							(16 + ($elem["maxlength"] - 16) / 4);
						if ($size == 0) $size = 20;
						$value = ($default == "") ? "" :
							" value='$default'";
						$maxlen = $elem["maxlength"] ?
							" maxlength='".$elem["maxlength"]."'" : "";
						$text2 = "<input type='$type' ".
							"name='$name$count$append' size='$size'$maxlen".
							"$value/>\n";
					}
				print table_element_line($text1,$text2);
			}	/* End of loop in case of verify. */
		}
	}

	print "</table>\n";
	print "<input type='hidden' name='profile' value='".$data["profile"].
		"'>\n";

	print "<input type='submit' value='".msg("Value", "Send",  "n")."'>\n";
	print "<input type='reset'  value='".msg("Value", "Reset", "n")."'>\n";
	print "</form>\n";
}

print_html_footer();

?>
