<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

/* Obsolete */

/*
 * Centralisation of variables which can be useful to various PHP scripts.
 */

/* TODO only include this when it is really needed? */

/* Mandatory fields. */
$star = '<strong class="highlight">*</strong> ';

/* LDAP names for DN elements: standard variable name => LDAP name. */
$ldap_names = array (
	"commonName"             => "CN",
	"uniqueIdentifier"       => "UID",
	"userID"                 => "userID",
	"emailAddress"           => "Email",
	"title"                  => "T",
	"description"            => "D",
	"organizationalUnitName" => "OU",
	"organizationName"       => "O",
	"localityName"           => "L",
	"stateOrProvinceName"    => "ST",
	"countryName"            => "C",
);

/* Note this must match the list in the Extension.inc i18n file */
$List_of_Extensions = array (
	"KeyUsageExtension" => array (
		"digitalSignature",
		"nonRepudiation",
		"keyEncipherment",
		"dataEncipherment",
		"keyAgreement",
		"keyCertSign",
		"cRLSign",
		"encipherOnly",
		"decipherOnly",
	),
	"ExtendedKeyUsageExtension" => array (
		"emailProtection",
		"clientAuth",
		"serverAuth",
		"codeSigning",
		"timeStamping",
	),
	"NetscapeExtensions" => array (
		"NSclient",
		"NSserver",
		"NSemail",
		"NSobjsign",
		"NSreserved",
		"NSsslCA",
		"NSemailCA",
		"NSobjCA",
	),
);

/* IDX-PKI modules: module code => module directory. */
$modules = array (
	"ee"     => "EE",
	"ra"     => "RA",
	"ca"     => "CA",
	"escrow" => "escrow",
	"config" => "config",
	"logs"   => "logs",
	/* This one is only used for the demo at https://demo.idx-pki.com/,
	   but maybe some day somebody else will be interested in it. */
	"management" => "management",
);

/* This is not a variable but this is useful for many scripts. */
/* Checks which modules are presents and returns only them (name => dir). */
function avail_mods ($long = "short") {
	global $modules;
	global $relativepath;

	$modlinks = array ();
	foreach ($modules as $mod => $dir) {
		/*
		 * http://uk.php.net/manual/en/function.is-file.php says: do not
		 * use is_file() because the unpatched PHP's out there (such as
		 * Mandrake's) would warn you if you do this on a nonexistent
		 * file. Hmm, looks like there are people at Zend that still have
		 * a lot to learn as regards operating system semantics...
		 */
		if (file_exists("$relativepath/$dir/index.php") ||
			file_exists("$relativepath/$dir/index.html")) {
			array_push ($modlinks, html_link ("$relativepath/$dir/",
				msg (($long == "long" ? "EntityList" : "ShortEntityList" ),
				$mod, "i"), "l"));
		}
	}
	return $modlinks;
}

/* Sort of Data::Dumper for PHP. */
function dumper($x, $l = "") {
	$r = "";
	if(is_array($x)) {
		$r .= "Array {\n";
		foreach($x as $k => $v) {
			$r .= $l.$k." => ".dumper($v, "\t$l");
		}
		$r .= "$l}\n";
	} else {
		$r = "$x\n";
	}
	return $r;
}

?>
