<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

/* $Id: privs.php,v 1.25 2003/05/16 13:16:42 mbrossard Exp $ */
/* $Source: /opt/cvs/idxpki/sources/src/php/config/privs.php,v $ */

$section = $HTTP_GET_VARS["section"];
$relativepath = "..";
include_once "$relativepath/pki-shared.inc";

print_html_header("config", $section, $relativepath);

/* Get the return value of the cgi. */
$data = getData();

/* Don't forget, changeprivs.cgi and listprivs.cgi are awaiting a
   'section=ACL-*' parameter. */

/*
 * System administration rights are still editable here. But they aren't
 * used any longer right in the PKI, are they?
 */
if (isset($data)) {
	if ((int)$data < 0) {
		/* Maybe this is not a standard error: Then display only the
		   appropriate message. */
		$doneerror = 0;
		for ($i = 0; isset($HTTP_GET_VARS["ORIG_MODIFY_DN_$i"]); $i++) {
			$error = $HTTP_GET_VARS["ERROR_MODIFY_DN_$i"];
			if ($error == "PERMISSION_DENIED") {
				error("NoModifyOwnAccessRights");
				$doneerror = 1;
			}
			elseif ($error =="DUPLICATE") {
				# The user #$i already exists.
				print yellow_msg
					("", sprintf (msg ("Error", "UserExists"), $i), "error");
				$doneerror = 1;
			}
		}
		/* This must be a standard error. */
		if (! $doneerror) {
			$field = strip_tags ($HTTP_GET_VARS["ERROR"]);
			error ((int) $data, ($field ? msg ("Form", $field, 'i') : ''));
		}
		print html_link('listprivs.cgi?section='.$section,
		msg("Message", "BackToMenu", "i"), "l", "para");
	} else {
		do_msg("Message", "CurrentConfiguration", "h2");

		if (count ($data) != 0) {
			print "<form action='changeprivs.cgi' method='post'>\n";
			print "<input type='hidden' name='section' value='$section'>\n";
			print begin_table ();
			print "<tr>\n";
			print "<td align='center'><strong class='formTitle'>".
				msg ("Configuration", "DN", "i")."</strong></td>\n";
			print "<td align='center'><strong class='formTitle'>".
				msg ("Configuration", "Use", "i")."</strong></td>\n";
			print "<td align='center'><strong class='formTitle'>".
				msg ("Configuration", "Config", "i")."</strong></td>\n";
			print "<td align='center'><strong class='formTitle'>".
				msg ("Configuration", "Privs", "i")."</strong></td>\n";
			print "<td align='center'><strong class='formTitle'>".
				msg ("Configuration", "Sysadm", "i")."</strong></td>\n";
			print "</tr>\n";

			$count = 0;
			foreach ($data as $k => $v) {
				/* Warning, $k may contain "'"s. */
				print "<tr>\n";
				print "<td>$k<input type='hidden' name='MODIFY_DN_$count' ".
					"value=\"$k\"></td>\n";

				foreach (array ("USE", "CONFIG", "CHPRIV", "MAINT") as $priv) {
					print "<td align='center'><input type='checkbox' ".
						"value='y' name='SET_PRIV_${priv}_$count'".
						(in_array ("PRIV_$priv", $v) ? " checked" : "").
						"></td>\n";
				}
				$count += 1;
			}
			print end_table ();

			print "<input type='submit' value='".
				msg ("Value", "SaveModifications", "n")."'>\n";
			print "</form>\n";
		} else {
			do_msg ("Message", "CurrentlyNoAdministratorDefined", "p");
		}

		print "<hr>\n";

		/* user add */
		$count=0;
		do_msg("Configuration", "AddAnAdministrator", "h2");

		print "<form action='config-certs-search.cgi' method='post'>\n";
		print "<input type='hidden' name='section' value='$section'>\n";
		print "<table width='100%' border='0' cellspacing='0' ".
			"cellpadding='5' bgcolor='#E5ECEE'>\n";
		foreach (array ("idxpkiSubjectID", "idxpkiSubjectEmail",
						"idxpkiSerial") as $k) {
			$v = msg ("Form", $k, "i");
			print "<tr>\n";
			print "<td><font face='Arial Narrow, Geneva, Arial' size='2' ".
				"color='#00415A'>$v:</font></td>\n";
			print "<td><input type='text' name='$k' value='".
				$HTTP_GET_VARS[$k]."'></td>\n";
			print "</tr>\n";
		}
		print "</table>\n";
		print "<input type='submit' value='".msg("Value","Search", "n").
			"'>\n</form>\n";

		/*

		print '<form action="changeprivs.cgi" method="post">
<input type="hidden" name="section" value="'.$section.'">
<table>
  <tr>
    <td><span class="formTitle">'.msg("Configuration", "DN", "i").
       '</span></td>
    <td><span class="formTitle">'.msg("Configuration", "Use", "i").
       '</span></td>
    <td><span class="formTitle">'.msg("Configuration", "Config", "i").
       '</span></td>
    <td><span class="formTitle">'.msg("Configuration", "Privs", "i").
       '</span></td>
    <td><span class="formTitle">'.msg("Configuration", "Sysadm", "i").
       '</span></td>
  </tr>';

		$U = '<input type="checkbox" name="SET_PRIV_USE_'.$count.'" checked value="y">';
		$O = '<input type="checkbox" name="SET_PRIV_CONFIG_'.$count.'">';
		$P = '<input type="checkbox" name="SET_PRIV_CHPRIV_'.$count.'">';
		$M = '<input type="checkbox" name="SET_PRIV_MAINT_'.$count.'">';
		print '
  <tr>
    <td><input type=text name=MODIFY_DN_'.$count.' width="50"></td>
    <td>'.$U.'</td><td>'.$O.'</td><td>'.$P.'</td><td>'.$M.'</td>
  </tr>
</table>
<br>
<input type="submit" value="'.msg("Value", "Add", "n").'">
<br>

<input type="hidden" name="section" value="'.$section.'">
</form>

	<hr>

';

		*/

	}
} else {
	error("PageMustFirstBeCalledFrom",
		  html_link("listprivs.cgi?section=$section", "listprivs.cgi"));
}

print_html_footer();

?>