<?php
/*
 * This code was developped by IDEALX (http://IDEALX.org/).
 * 
 * Copyright  2000-2003 IDEALX
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

$DEFAULT_DEBUG  = 0;
if (! isset($relativepath) or (strlen($relativepath) == 0)) {
	$relativepath = ".";
}
include "$relativepath/i18n/lang.inc";

$MSG = array();
global $MSG;

if ($DEFAULT_DEBUG) {
	phpinfo();
}

if (! isset($debug)) {
	$debug = $DEFAULT_DEBUG;
}

##############################################################################

function _DEBUG($tmp) {
	global $debug;
	if (! $debug) {
		return;
	}
	print "<p><font color='blue'><font size='-1'>$tmp</font></font></p>\n";
}

function _ERROR($tmp) {
	print "<p><font color='red'><font size='+1'>".
		"<strong>XXX $tmp</strong></font></font></p>\n";
}

# Returns a true value if the language exists
function _exists_language($l) {
	global $relativepath, $KNOWN_LANGUAGES, $debug;
	if (! isset($KNOWN_LANGUAGES["$l"]) ) {
		return 0;
	}
	$lang_file = "$relativepath/i18n/$iso";
	if ($fp = @fopen($lang_file, "r")) {
		@fclose($fp);
		return 1;
	} elseif ($debug) {
    	_DEBUG("Cannot open directory for lang '$iso'");
		@fclose($fp);
		$fp = fopen($lang_file, "r");
		fclose($fp);
	}
	return 0;
}

function choose_language() {
	global $HTTP_SERVER_VARS, $CONFIG_DEFAULT_LANGUAGE, $DEFAULT_LANGUAGE,
		$debug;

	/* Sets the default language (as used later) as the configured default
	   language, if available. */
	if (isset($CONFIG_DEFAULT_LANGUAGE) &&
		_exists_language($CONFIG_DEFAULT_LANGUAGE)) {
		_DEBUG("Setting default language as configured: ``$lang''");
		$DEFAULT_LANGUAGE = $CONFIG_DEFAULT_LANGUAGE;
	}

	if (isset($HTTP_SERVER_VARS["HTTP_ACCEPT_LANGUAGE"])) {
		$http_accept_language = $HTTP_SERVER_VARS["HTTP_ACCEPT_LANGUAGE"];

		_DEBUG("``Accept-Language:'' field is: ``$http_accept_language''");

		/* Removing annoying q=value bits */
		$http_accept_language = preg_replace('/;q=\d*\.\d*(?:,|$)/', ",",
			$http_accept_language);
		/* Replacing all blanks with spaces */
		$http_accept_language = preg_replace('/\s+/', " ",
			$http_accept_language);
		/* Making sure the last character is a comma */
		$http_accept_language = preg_replace('/([^,])$/', "$1,",
			$http_accept_language);
		/* Making sure the first character is a blank */
		$http_accept_language = preg_replace('/^([^\s])/', " $1",
			$http_accept_language);

		_DEBUG("After cleanup it is: ``$http_accept_language''");

		preg_match_all('/\s*([^,]+),/', $http_accept_language, $matches,
			PREG_PATTERN_ORDER);

		$count = count($matches[1]);
		_DEBUG("Counted ``$count'' languages");

		_DEBUG("Trying with the exact names of languages...");
		for ($i=0; $i<$count; $i++) {
			$l = $matches[1][$i];
			$n = $i + 1;
			_DEBUG("Language ``$n'' is ``$l''");
			if (_exists_language($l)) {
				_DEBUG("That language exists! Choosing that...");
				return($l);
			} elseif ($debug) {
				_DEBUG("That language does not exist in my list ".
					"or is not installed...");
			}
		}

		_DEBUG("Trying stripping hyphens of the languages names...");
		for ($i=0; $i<$count; $i++) {
			$l = preg_replace('/\-.*/', '', $matches[1][$i]);
			$n = $i + 1;
			_DEBUG("Stripped language ``$n'' is ``$l''");
			if (_exists_language($l)) {
				_DEBUG("That language exists! Choosing that...");
				return ($l);
			} elseif ($debug) {
				_DEBUG("That language does not exist in my list ".
					"or is not installed...");
			}
		}
	}

	/* If we reach this point the Accept-Languages: field proved useless */
	if (isset($CONFIG_DEFAULT_LANGUAGE)) {
		/* TODO code this in the install script */
		if (_exists_language($CONFIG_DEFAULT_LANGUAGE)) {
			_DEBUG("Using config default language: ``$lang''");
			return $CONFIG_DEFAULT_LANGUAGE;
		} elseif ($debug) {
			_DEBUG("XXX Config default language ``$CONFIG_DEFAULT_LANGUAGE'' ".
				"does not exist in my list or is not installed...");
		}
	} else { /* This one should be installed! */
		_DEBUG("Using default language: ``$DEFAULT_LANGUAGE''");
		return $DEFAULT_LANGUAGE;
	}
}

# Choice of the language if no session language is defined

if (! isset($lang) || $lang == "") {
	$lang = ($HTTP_GET_VARS["TRUSTED_lang"]) ?
		$HTTP_GET_VARS["TRUSTED_lang"] : choose_language();
}

function error($msg, $extra = "") {
	//do_msg("Error", $msg, "error", $extra);
	//return msg("", $msg,"" , $extra);
	print yellow_msg("Error",$msg,"error", $extra);
	//return msg("Error", $msg, "error", $extra="");
}

function current_language() {
	global $lang, $KNOWN_LANGUAGES;
	return "[" . $KNOWN_LANGUAGES["$lang"] . "]";
}

# Prints the current language
function print_current_language() {
	print "<p>" . current_language() . "</p>\n";
}

function html_link($href, $text, $l="", $in_para="", $attr="") {
	global $DEFAULT_LANGUAGE, $lang;

	/* FIXME CMH - Removal of lang parameter - Temporary until more
	   refactoring is done. This should allow to look for dependencies on
	   this in perlscripts. */

	/*
	if (strlen($l)>0) {
		$l = "lang=$lang";
	}
	*/

	$l="";

	if (strlen($l)>0) {
		if (preg_match("/\?/", $href)) {
			/* There is already one or more variables passed in the URL. */
			$l = '&amp;'.$l;
		} else {
			/* There is no variable passed in the URL. */
			$l = "?".$l;
		}
	}

	if (strlen($attr)>0) {
		$attr = " ".$attr;
	}
	if ($in_para == "menu") {
		return '<td align="center" bgcolor="#E1E1E1" onmouseover="style.backgroundColor=\'#F5F5F5\'; style.cursor=\'hand\';"
						 onmouseout="style.backgroundColor=\'#E1E1E1\';" onclick="location.href=\''.$href.$l.'\'">
		<font face="Trebuchet MS, Arial, Helvetica, sans-serif" size="2" color="#666666"><b><a href="'.$href.$l.'" '.$attr.'>'.$text.'</a></b></font>
	    </td>';
	} else {
		return "<a href='$href$l'>$text</a>";
	}
}

function html_begin($title="XXX ??? XXX", $head="", $body_attr="") {
	global $lang, $ENCODING_LANGUAGES;

	$character_encoding = "";
	if (isset($ENCODING_LANGUAGES[$lang])) {
		$character_encoding = $ENCODING_LANGUAGES[$lang];
	} else {
		_DEBUG("No encoding for the language '$lang'");
	}

	print "<html>\n$character_encoding<head>\n".
		"<title>$title</title>\n".
		"$head</head>\n".
		"<body $body_attr>\n";
}

function html_end() {
	print "\n</body>\n</html>\n";
}

/* Returns the list of other languages to choose from. */
function list_of_langs() {
	global $KNOWN_LANGUAGES, $lang, $debug, $relativepath;
	$res = "";

	foreach ($KNOWN_LANGUAGES as $iso => $lang_name) {
		if ($iso != $lang) {
			if (_exists_language($iso)) {
				$res .= "<option value='$iso'>$lang_name</a>";
			}
		} else {
			$res .= "<option value='$iso' selected>$lang_name</a>";
		}
	}
	return $res;
}

/* We check a message exists in a class. For this we always load the
   default language version... */
function is_there($class, $message) {
	global $MSG, $DEFAULT_LANGUAGE;

	if (! isset($MSG[$class][$DEFAULT_LANGUAGE])) {
		/* Reading the default language version now that a message is
		   missing... */
		$default_language_defs = $relativepath.
			"/i18n/". $DEFAULT_LANGUAGE."/".$class.".inc";
		if ($fp = @fopen($default_language_defs, "r")) {
			@fclose($fp);
			_DEBUG("Including $default_language_defs...");
			include $default_language_defs;
		} else {
			_ERROR("Cannot load '$default_language_defs'!");
		}
	}

	return (isset($MSG[$class][$DEFAULT_LANGUAGE]));
}

/* Returns a message in the correct language and in the correct tagging. */
function msg($class, $message, $typeset = "para", $extra="") {
	global $lang, $MSG, $DEFAULT_LANGUAGE, $relativepath;
	$default_lang_tag = "em";
	$default_lang_flag = 0;

	_DEBUG("DEBUG: function msg($class, $message, $typeset) (lang=$lang)");

	/* Reading the special language version. */
	if (! isset($MSG[$class][$lang])) {
		$lang_defs = $relativepath. "/i18n/". $lang."/".$class.".inc";
		if ($fp = @fopen($lang_defs, "r")) {
			@fclose($fp);
			_DEBUG("Including $lang_defs...");
			include $lang_defs;
			if (! isset($MSG[$class][$lang])) {
				_ERROR("File $lang_defs does not define MSG for ".
					   "$class/$lang");
			}
		} else {
			_DEBUG("Could not find $lang_defs... will load default ".
				   "language version");
			/* So we do not try to load it again later. */
			$MSG[$class][$lang] = array();
		}
	}

	if (isset($MSG[$class][$lang][$message])) {
		$msg = $MSG[$class][$lang][$message];
		_DEBUG("FOUND THE MESSAGE FOR $class/$lang/$message");
	} else {
		if (! isset($MSG[$class][$DEFAULT_LANGUAGE])) {
			/* Reading the default language version now that a message is
			   missing... */
			$default_language_defs = $relativepath.
				"/i18n/". $DEFAULT_LANGUAGE."/".$class.".inc";
			if ($fp = @fopen($default_language_defs, "r")) {
				@fclose($fp);
				_DEBUG("Including $default_language_defs...");
				include $default_language_defs;
			} else {
				_ERROR("Cannot load '$default_language_defs'!");
			}
		}

		if (isset($MSG[$class][$DEFAULT_LANGUAGE][$message])) {
			$msg = $MSG[$class][$DEFAULT_LANGUAGE][$message];
			$default_lang_flag = 1;
			_DEBUG("USING DEFAULT LANGUAGE '$DEFAULT_LANGUAGE' FLAG ".
				   "for $class/$lang/$message");
		} else {
			$msg = "XXX MESSAGE $class/$message NOT IN DEFAULT LANGUAGE ".
				"$DEFAULT_LANGUAGE";
			if (($typeset != "naked") && ($typeset != "n")) {
				$msg = "<font color='red'><strong>$msg</strong></font>";
			}
		}
	}

	if (($typeset == "para") or ($typeset == "p")) {
		$tag_begin = "p";
		$tag_end   = "p";
	} elseif ($typeset == "listitem") {
		$tag_begin = "li";
		$tag_end   = "li";
	} elseif (($typeset == "naked") or ($typeset == "n")) {
		return $msg;
	} elseif (($typeset == "inline") or ($typeset == "i")) {
		/* $default_lang_flag = 0; */
		/* Nothing. */
	} elseif (($typeset == "error") or ($typeset == "e")) {
		$tag_begin = "p class='error'";
		$tag_end   = "p";
	} elseif ($typeset == "h2") {
		$tag_begin = "h2";
		$tag_end   = "h2";
	} else {
		_ERROR("Unknown typeset: '$typeset'");
	}

	if ($default_lang_flag == 1) { /* In non naked or other problem mode... */
		$msg = "<$default_lang_tag>$msg</$default_lang_tag>";
	}
	if (($typeset == "inline") or ($typeset == "i")) {
		return $msg;
	}
	return "<$tag_begin>$msg$extra</$tag_end>\n";
}

function do_msg($class, $message, $typeset = "para", $extra="") {
	print msg($class, $message, $typeset, $extra);
}

/* Returns the profile title for the current language from the array
   provided by perlscripts. */
function getProfileTitleI18N($titles) {
	global $lang;
	if (isset($titles[$lang])) {
		return $titles[$lang];
	} else {
		return $titles["default"];
	}
}

?>
