<?php

include_once "$relativepath/CompileTime.inc";	/* Keep it first! */
include_once "$relativepath/i18n/i18n.inc";
include_once "$relativepath/presentation.inc";

function parseEncodedData($Data)
{
	if ($Data) {
		if (get_magic_quotes_gpc ()) {
			$Data = stripslashes ($Data);
		}
		eval ("\$Data = $Data;");
	}
	return $Data;
}

function getVariable($variable)
{
	global $HTTP_SERVER_VARS;
	global $HTTP_ENV_VARS;

	$contents = $HTTP_SERVER_VARS["REDIRECT_$variable"];
	if (! isset ($contents)) {
		$contents = $HTTP_ENV_VARS["$variable"];
	}
	return parseEncodedData ($contents);
}

function getData()
{
	$data = getVariable ("IDXPKI_DATA"); /* CGI-style. */
	if (! isset ($data)) $data = getVariable ("DATA"); /* Registry-style. */
	return $data;
}

function getProfile()
{
	return getVariable ("IDXPKI_PROFILE");
}

/* Sort everything below */

/* Mandatory fields. */
$star = '<strong class="highlight">*</strong> ';

/* LDAP names for DN elements: standard variable name => LDAP name. */
$ldap_names = array (
	"commonName"             => "CN",
	"uniqueIdentifier"       => "UID",
	"userID"                 => "userID",
	"emailAddress"           => "Email",
	"title"                  => "T",
	"description"            => "D",
	"organizationalUnitName" => "OU",
	"organizationName"       => "O",
	"localityName"           => "L",
	"stateOrProvinceName"    => "ST",
	"countryName"            => "C",
);

/* Note this must match the list in the Extension.inc i18n file */
$List_of_Extensions = array (
	"KeyUsageExtension" => array (
		"digitalSignature",
		"nonRepudiation",
		"keyEncipherment",
		"dataEncipherment",
		"keyAgreement",
		"keyCertSign",
		"cRLSign",
		"encipherOnly",
		"decipherOnly",
	),
	"ExtendedKeyUsageExtension" => array (
		"emailProtection",
		"clientAuth",
		"serverAuth",
		"codeSigning",
		"timeStamping",
	),
	"NetscapeExtensions" => array (
		"NSclient",
		"NSserver",
		"NSemail",
		"NSobjsign",
		"NSreserved",
		"NSsslCA",
		"NSemailCA",
		"NSobjCA",
	),
);

/* IDX-PKI modules: module code => module directory. */
$modules = array (
	"ee"     => "EE",
	"ra"     => "RA",
	"ca"     => "CA",
	"escrow" => "escrow",
	"config" => "config",
	"logs"   => "logs",
	/* This one is only used for the demo at https://demo.idx-pki.com/,
	   but maybe some day somebody else will be interested in it. */
	"management" => "management",
);

/* This is not a variable but this is useful for many scripts. */
/* Checks which modules are presents and returns only them (name => dir). */
function avail_mods ($long = "short") {
	global $modules;
	global $relativepath;

	$modlinks = array ();
	foreach ($modules as $mod => $dir) {
		/*
		 * http://uk.php.net/manual/en/function.is-file.php says: do not
		 * use is_file() because the unpatched PHP's out there (such as
		 * Mandrake's) would warn you if you do this on a nonexistent
		 * file. Hmm, looks like there are people at Zend that still have
		 * a lot to learn as regards operating system semantics...
		 */
		if (file_exists("$relativepath/$dir/index.php") ||
			file_exists("$relativepath/$dir/index.html")) {
			array_push ($modlinks, html_link ("$relativepath/$dir/",
				msg (($long == "long" ? "EntityList" : "ShortEntityList" ),
				$mod, "i"), "l"));
		}
	}
	return $modlinks;
}

/* Sort of Data::Dumper for PHP. */
function dumper($x, $l = "") {
	$r = "";
	if(is_array($x)) {
		$r .= "Array {\n";
		foreach($x as $k => $v) {
			$r .= $l.$k." => ".dumper($v, "\t$l");
		}
		$r .= "$l}\n";
	} else {
		$r = "$x\n";
	}
	return $r;
}


?>